#ifndef CAMERA_DRIVING_PERCEPTION_THREE_GENERAL_WRAPPER_HEADER_H
#define CAMERA_DRIVING_PERCEPTION_THREE_GENERAL_WRAPPER_HEADER_H
#include "sub/SubWrapperHelper.h"
#include "sub/SubDataWrapper.h"
#include "CameraDrivingPerceptionThree_SubDataWrapper.h"
#include "pub/PubWrapperHelper.h"
#include "pub/PubDataWrapper.h"
#include "CameraDrivingPerceptionThree_PubDataWrapper.h"
#include "camera_driving_perception_three/executable.h"

using namespace jac::ap::cameradrivingservice::proxy;
using namespace jac::ap::cameradrivingperservice::skeleton;
using namespace jac::ap::canservice::proxy;
using namespace jac::ap::slamservice::proxy;
using namespace jac::ap::vedservice::proxy;

//PubWrappers
GENERATE_PUB_WRAPPER(CamDrvPerceptionThree2Fusion_Provide, CamDrvPerceptionThree2Fusion_PubDataWrapper, CameraDrivingPerceptionServiceSkeleton, perception::vector_CameraPerception2Fusion, CameraDrvPerception2FusionEvent);
//SubWrappers
GENERATE_SUB_WRAPPER(CamDrv2CamDrvPerceptionThree_Required, CamDrv2CamDrvPerceptionThree_SubDataWrapper, CameraDrivingServiceProxy, perception::Cam2CamPerceptionStruct, CamDrv2CamDrvPerceptionThreeEvent, "16", 10);
GENERATE_SUB_WRAPPER(Slam2DrvPerceptionThreeOdom_Required, Slam2DrvPerceptionThreeOdom_SubDataWrapper, SLAMServiceProxy, dpc::slam_odometry, SLAMOdometryEvent, "8", 10);
GENERATE_SUB_WRAPPER(CAN2DrvPerceptionThree_Required, CAN2DrvPerceptionThree_SubDataWrapper, CANServiceProxy, CAN2SWC, CAN2SWCEvent, "3", 10);
GENERATE_SUB_WRAPPER(VED2DrvPerceptionThree_Required, VED2DrvPerceptionThree_SubDataWrapper, VEDServiceProxy, dpc::VED4FusionEgoMotion, VED2FusionEgoMotionEvent, "11", 10);

class GeneralWrapper {
public:
    //Provides
    CamDrvPerceptionThree2Fusion_Provide _CamDrvPerceptionThree2Fusion_Provide;
    //Requireds
    CamDrv2CamDrvPerceptionThree_Required _CamDrv2CamDrvPerceptionThree_Required;
    Slam2DrvPerceptionThreeOdom_Required _Slam2DrvPerceptionThreeOdom_Required;
    CAN2DrvPerceptionThree_Required _CAN2DrvPerceptionThree_Required;
    VED2DrvPerceptionThree_Required _VED2DrvPerceptionThree_Required;
    
    GeneralWrapper(ara::log::Logger& mainLog);
    ~GeneralWrapper();
    void Start();
};


#endif
